<?xml version="1.0"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:mml="http://www.w3.org/1998/Math/MathML"
	targetNamespace="http://www.13cflux.net/fluxml"
	xmlns="http://www.13cflux.net/fluxml"
	xmlns:f="http://www.13cflux.net/fluxml"
	elementFormDefault="qualified">

<xs:import
    namespace="http://www.w3.org/1998/Math/MathML"
    schemaLocation="http://www.w3.org/Math/XMLSchema/mathml2/mathml2.xsd"/>	

<!-- Code de vérification des entrées du fichier d'entrée fml -->
<xs:element name="fluxml">
  <xs:complexType>
    <xs:sequence>
    	<!-- element info optionnel -->
      <xs:element name="info" maxOccurs="1"/>
      <!-- element reactionnetwork -->
      <xs:element name="reactionnetwork">
		  <xs:complexType>
		   	<xs:sequence>
		   		<!-- element fils metabolitepools -->
		      <xs:element name="metabolitepools" type="metapoolstype"/>
		   		<!-- element fils reaction -->
		      <xs:element name="reaction" type="reactiontype" minOccurs="2" maxOccurs="unbounded"/> 	      
		   	</xs:sequence>
		  </xs:complexType>
		  <!-- clef sur l'identificateur des metabolites  -->
		  <xs:key name="metaboliteKey">
			<xs:selector xpath="f:metabolitepools/*"/>
		    <xs:field xpath="@id"/>
		   </xs:key>
		   <!-- reference sur les identificateurs de metabolites pour les substrats et les produits -->
		   	<xs:keyref name="metaboliteRef" refer="metaboliteKey">
				<xs:selector xpath="f:reaction/*"/>
				<xs:field xpath="@id"/>
			</xs:keyref>
      </xs:element>
      <!-- element constraints -->
      <xs:element name="constraints" maxOccurs="1" type="constrtype"/>
      <!-- element configuration -->
      <xs:element name="configuration" type="configtype"/>
    </xs:sequence>
  </xs:complexType>
  <!-- clef sur l'ientificateur des donnees marquees -->
	<xs:key name="dataKey">
		<xs:selector xpath="f:configuration/f:measurement/f:model/*/*"/>
		<xs:field xpath="@id"/>
	</xs:key>
	<!-- clef sur l'identificateur des flux mesurés -->
	<!-- <xs:key name="fluxKey">
		<xs:selector xpath="f:configuration/f:measurement/f:model/f:fluxmeasurement/*"/>
	<xs:field xpath="@id"/>
		   	</xs:key> -->
  <!-- reference sur les identificateurs de donnees marquees pour les mesures -->
	<xs:keyref name="dataRef" refer="dataKey">
		<xs:selector xpath="f:configuration/f:measurement/f:data/*"/>
		<xs:field xpath="@id"/>
	</xs:keyref>
  
	<xs:keyref name="inputRef" refer="metaboliteKey">
	<xs:selector xpath="f:configuration/f:input"/>
	<xs:field xpath="@pool"/>
</xs:keyref>
  
  
  
	<!-- reference sur les identificateurs des flux mesurés  -->
<!-- 	<xs:keyref name="fluxRef" refer="fluxKey">
		<xs:selector xpath="f:configuration/f:measurement/f:data/*"/>
		<xs:field xpath="@id"/>
	</xs:keyref> -->
</xs:element>


<!-- element : metabolitepools : definition du type metapoolstype -->
<xs:complexType name="metapoolstype">
	<xs:sequence>
		<xs:element name="pool" minOccurs="3" maxOccurs="unbounded">
			<xs:complexType>
				<!-- identificateur du métabolite de type ID	 -->
	    		<xs:attribute name="id" type="xs:ID" use="required"/>
	    		<!-- nombre d'atomes de carbone > 0 -->
				<xs:attribute name="atoms" type="xs:positiveInteger" use="required"/>
			</xs:complexType>						
		</xs:element>
	</xs:sequence>
</xs:complexType>

<!-- définition du type reactiontype -->
<xs:complexType name="reactiontype">
	<xs:sequence>
		<!-- substrat de type metatype -->
		<xs:element name="reduct" type="metatype" maxOccurs="unbounded"/>
		<!-- produit de type metatype -->
 		<xs:element name="rproduct" type="metatype" minOccurs="0" maxOccurs="unbounded"/>
	</xs:sequence>	
	<!-- identificateur de la reaction de type ID-->
	<xs:attribute name="id" type="xs:ID" use="required"/>
</xs:complexType>

<!-- type metatype vide, constitué uniquement de deux attributs -->
<xs:complexType name="metatype">  	
	<xs:attribute name="cfg" use="required">
		<!-- definition du type de l'attribut cfg -->
		<xs:simpleType>
			<xs:restriction base="xs:string">
				<xs:pattern value="([A-Za-z]*)"/>
				<xs:minLength value="1"/>
			</xs:restriction>
		</xs:simpleType>
	</xs:attribute>
	<xs:attribute name="id" type="xs:IDREF" use="required"/>   
</xs:complexType>


<!-- element : constraints -->
<xs:complexType name="constrtype">
<xs:sequence>
	<!-- element fils net -->
	<xs:element name="net" maxOccurs="1" type="mmltype"/>
	<!-- element fils xch -->
	<xs:element name="xch" maxOccurs="1" type="mmltype"/>
</xs:sequence>
</xs:complexType>

<!-- definition du type mmltype -->
<xs:complexType name="mmltype">
	<xs:sequence>
		<xs:element ref="mml:math"/>			
	</xs:sequence>
</xs:complexType>

<!-- element : configuration -->
<xs:complexType name="configtype">
	<xs:sequence>
		<!-- element fils input -->
		<xs:element name="input" minOccurs="1" maxOccurs="unbounded">
			<!-- type de l'environnement input -->
			<xs:complexType>
				<xs:sequence>
					<!-- element fils label -->
					<xs:element name="label" type="labeltype" maxOccurs="unbounded"/>
				</xs:sequence>
				<!-- attribut du metabolite d'entrée -->
    			<xs:attribute name="pool" type="xs:IDREF" use="required"/> 
          <xs:attribute name="type" default="isotopomer" use="optional">
            <xs:simpleType>
              <xs:restriction base="xs:string">
                <xs:enumeration value="isotopomer"/>
              </xs:restriction>
            </xs:simpleType>
          </xs:attribute>
			</xs:complexType>
			<!-- reference sur les identificateurs de metabolites pour le substrat d'entree -->
		</xs:element>
		<!-- element fils measurement -->
		<xs:element name="measurement" type="measuretype"/>
	</xs:sequence>
  <xs:attribute name="name" type="xs:string" use="required"/>
  <xs:attribute name="stationary" type="xs:boolean" default="true"/>
</xs:complexType>

<!-- definition du type labeltype -->
<xs:complexType name="labeltype">
	<xs:simpleContent>
		<!-- proportion du marquage isotopique -->
		<xs:extension base="qtype">
			<!-- configuration identifiee en binaire -->
			<xs:attribute name="cfg" use="required">
				<!-- type de suites de 0 et 1 -->
				<xs:simpleType>
					<xs:restriction base="xs:integer">
						<xs:pattern value="([0-1]*)"/>
					</xs:restriction>
				</xs:simpleType>
			</xs:attribute>
 		</xs:extension>		
	</xs:simpleContent>	
</xs:complexType>

<!-- proportion q du marquage telle que 0 \leq q \leq 1 -->
<xs:simpleType name="qtype">
	<xs:restriction base="xs:decimal">
  			<xs:minInclusive value="0"/>
 			<xs:maxInclusive value="1"/> 
	</xs:restriction>
</xs:simpleType>

<!-- element : measurement -->
<xs:complexType name="measuretype">
	<xs:sequence>
		<xs:element name="model">
			<xs:complexType>
				<xs:sequence>
					<xs:element name="labelingmeasurement" type="lmeasuretype"/>
					<xs:element name="fluxmeasurement" type="fmeasuretype"/>		
				</xs:sequence>
			</xs:complexType>
		</xs:element>
		<xs:element name="data">
			<xs:complexType>
				<xs:sequence>
					<xs:element name="datum" type="datumtype" maxOccurs="unbounded"/>
				</xs:sequence>	
			</xs:complexType>
		</xs:element>		
	</xs:sequence>
</xs:complexType>

<!-- element : labelingmeasurement -->
<xs:complexType name="lmeasuretype">
	<xs:sequence>
		<!-- element fils group -->
		<xs:element name="group" maxOccurs="unbounded">
			<!-- type de l'element group -->
			<xs:complexType>
				<xs:all>	
					<xs:element name="textual" type="xs:string"/>		
				</xs:all>
				<!-- attribut scale -->
				<xs:attribute name="scale" type="xs:string"/>
				<!-- identificateur id de type ID -->
				<xs:attribute name="id" type="xs:ID" use="required"/>
			</xs:complexType>
		</xs:element>
	</xs:sequence>       		
</xs:complexType>


<!-- element : fluxmeasurement -->
<xs:complexType name="fmeasuretype">
	<xs:sequence>
		<!-- element fils netflux -->
		<xs:element name="netflux">
			<xs:complexType>
				<xs:all>	
					<xs:element name="textual" type="xs:string"/>		
				</xs:all>
				<!-- identificateur id de type ID -->
				<xs:attribute name="id" type="xs:ID" use="required"/>
			</xs:complexType>
		</xs:element>
	</xs:sequence>       		
</xs:complexType>

<!-- definition du type datumtype -->
<xs:complexType name="datumtype">
	<xs:simpleContent>
		<xs:extension base="xs:decimal">
 			<xs:attribute name="id" type="xs:IDREF" use="required"/>
			<xs:attribute name="stddev" type="xs:decimal"/>
			<xs:attribute name="weight" type="xs:nonNegativeInteger"/>
 		</xs:extension>
	</xs:simpleContent>
</xs:complexType>

</xs:schema>